# ==============================================================================================
# SeparatednesVariance.py 
# Count value of Spots (Polygons) Separatednes (Interval dead reckogning variance parameter of location of input Feature Class) 
# coordinates are relate to centroids
# Author: Katerina PAVKOVA, 2008
# ==============================================================================================

# import systems modules
import arcgisscripting, string, math, sys, locale

# import helper functions
from HelperFunctions import *

# create geoprocessor object
gp = arcgisscripting.create()

# input
try:
    InPolygFC = sys.argv[1]                  # Feature Layer
    Path = sys.argv[2]                       # Folder
except: raise ReportError (msgParseErr)

#-----------------------------------------------------------------------------------
# no records error
count = gp.GetCount(InPolygFC)                        # Counting records                                        
if count < 1:
        raise ReportError (msgNoRecsErr)

# feature type error 
description = gp.describe(InPolygFC)                  # describing shape type
if description.ShapeType <> "Polygon":              # when shype type is not polygon:
    raise ReportError(msgPolyOnlyErr)   

#-----------------------------------------------------------------------------------
# workspace
gp.workspace = "C:/temp/"
if not os.path.exists("C:/temp/"):
    if os.path.dirname(InPolygFC) <> "": gp.workspace = str(os.path.dirname(InPolygFC))
    else:
        message = ('\n''"C:/temp/" does not exist.'
                   '\nDo not load data as Feature Layer.\nPlease specify a path of Input Polygon Feature Class. \n ...'
                   '\n (Or rewrite workspace gp.workspace in the script.)\n\n')
        error = gp.GetMessages(2)
        OutMessage = message + "... " + error
        raise ReportError (OutMessage)

#-----------------------------------------------------------------------------------
# polygons to centroids
centroids = "centroids.shp"
try:
    gp.FeatureToPoint_management(InPolygFC, centroids)   
except: raise gp.GetMessages(2)

#--------------------------------------------------------------------------------------------
# adding x and ycoordinates into table
try:
    gp.AddXY_management(centroids)
except: raise gp.GetMessage(2)

# =====================================================================================
# looping through centroids table to count mean x and y coordinates
rows = gp.UpdateCursor(centroids)
row = rows.Next()
sumX = 0
sumY = 0
while row <> None:
    coorX = row.POINT_X
    sumX = sumX + coorX

    coorY = row.POINT_Y
    sumY = sumY + coorY

    row = rows.Next()
rows = None

# counting mean
meanX = sumX/count
meanY = sumY/count

gp.AddMessage("\n30% complete")

# looping through table to count variance numerator
rows2 = gp.UpdateCursor(centroids)
numerX = 0
numerY = 0
row2 = rows2.Next()
while row2 <> None:
    valueX = row2.GetValue("POINT_X")
    xminusmean2 = (valueX - meanX)*(valueX - meanX)
    numerX = numerX + xminusmean2
        
    valueY = row2.GetValue("POINT_Y")
    yminusmean2 = (valueY - meanY)*(valueY - meanY)
    numerY = numerY + yminusmean2
    
    row2 = rows2.Next()
rows2 = None

gp.AddMessage("70% complete")

# counting variance
varX = numerX/(count - 1)

varY = numerY/(count - 1)

#----------------------------------------------------------------------------------------

statTable = Path + "\\scripts\\table1.dbf"

rows3 = gp.UpdateCursor(statTable)
row3 = rows3.Next()
while row3 <> None:
    if row3.OID == count - 2:
        kapa1XY = row3.Z_975
        kapa2XY = row3.Z_025
    row3 = rows3.Next()
row3 = None

rightX = ((count - 1)*varX)/kapa1XY
leftX = ((count - 1)*varX)/kapa2XY

rightY = ((count - 1)*varY)/kapa1XY
leftY = ((count - 1)*varY)/kapa2XY

# resulting message
gp.AddMessage("\n IZOLOVANOST PLOSEK"'\n'
              'Intervalovy odhad parametru rozptylu polohy plosek v "' + str(InPolygFC) +'.shp":''\n'
              "D = suma((" + str(leftX) + "; " + str(rightX) + ") + (" + str(leftY) + "; " + str(rightY) + "))"'\n')


#--------------------------------------------------------------------------------------
# deleting temporary centroids shape
try:
    gp.delete_management(centroids)
except: raise gp.GetMessages(2)

gp = None    




    

