#===============================================================================
# Statistic.py
# calculate sum, min, max, med and mean value
# Author: Katerina PAVKOVA, 2008
#===============================================================================

# import systems modules 
import arcgisscripting, string, math, sys, locale

# import helper functions
from HelperFunctions import *

# create geoprocessor object
gp = arcgisscripting.create()

# input
try:
    InTable = sys.argv[1]                 # Table View
    InField = sys.argv[2]                 # Field
    OutTable = sys.argv[3]                # Table
    OutFile = sys.argv[4]                 # Text File

except: raise ReportError (msgParseErr)    
    
#----------------------------------------------------------------------------------------------
# wrong text file parameter error

if OutFile <> "" and OutFile <> "#":     # if this parameter exist
    if ".txt" not in OutFile:            # if text file do not contain ".txt"         
        OutFile = str(OutFile) + ".txt"
        print OutFile
    
    # if text file do not contain direction folder path
    if os.path.dirname(OutFile) == "":   
        if not os.path.dirname(InTable) == "":
            TextPath = os.path.dirname(InTable)
            gp.AddWarning ('Text file with results "' + str(OutFile) + '" is saved in "' + str(TextPath) + '\\".')
            print TextPath
            OutFile = str(TextPath) + "\\" + str(OutFile)
            print "poprvee " + str(OutFile)
            
        else:
            TextPath = gp.workspace = "C:/temp/"
            gp.AddWarning ('Text file with results "' + str(OutFile) + '" is saved in "C:/temp/".')
            OutFile = str(TextPath) + str(OutFile)
            print "podruhee " + str(OutFile)
            
            if not os.path.exists("C:/temp/"):
                message = '\n''"C:/temp/" does not exist. \nPlease specify a path to the results file.\n\n'
                error = gp.GetMessages(2)
                OutMessage = message + "... " + error
                raise ReportError (OutMessage)    
        
    # creating text file
    OutTxtFile = open(OutFile, "w")
        
#---------------------------------------------------------------------------------------
# no records error
count = gp.GetCount(InTable)                        # Counting records                                        
if count < 1:
        raise ReportError (msgNoRecsErr)

# ------------------------------------------------------------------------------------------
# wrong input field type error

# listing all fields, and getting their type
listFields = gp.ListFields(InTable)
Field = listFields.Next()
while Field:
    if Field.Name == InField:
        typ = Field.Type
    Field = listFields.Next()
print type

if typ <> "SmallInteger" and typ <> "Double" and typ <> "Integer" and typ <> "Single":
    message1 = "The choosen field can not be statisticaly processed.\n\n"
    Errors = gp.GetMessages(2)
    OutMessage = message1 + "... " + Errors
    raise ReportError (OutMessage)
    

#-----------------------------------------------------------------------------
# wrong OutTable parameter error
if OutTable <> "" and OutTable <> "#":          # if OutTable parameter exist:
    if ".dbf" not in OutTable:                  # OutTable do not contain ".txt"
        OutTable = str(OutTable) + ".dbf"
        print OutTable

    # OutTable do not contain direction folder path
    if os.path.dirname(OutTable) == "":
        if not os.path.dirname(InTable) == "":
            Path = os.path.dirname(InTable)
            gp.AddWarning ('Table with results "' + str(OutTable) + '" is saved in "' + str(Path) + '\\".')
            print "cesta1 = " + str(Path)
            OutTable = str(Path) + "\\" + str(OutTable)
            print "outtable = " + str(OutTable)

        else:
            Path = gp.workspace = "C:/temp/"
            print Path
            gp.AddWarning ('Table with results "' + str(OutTable) + '" is saved in "C:/temp/".')
            OutTable = str(Path) + str(OutTable)

            if not os.path.exists("C:/temp/"):
                message = '\n''"C:/temp/" does not exist. \nPlease specify a path to the results file.\n\n'
                error = gp.GetMessages(2)
                OutMessage = message + "... " + error
                raise ReportError (OutMessage)
     
    Path, Name = os.path.split(OutTable)
    print Path, Name

   #--------------------------------------------------------------------------------------------------
   # creating OutTable
    try:
        OutTable2 = gp.CreateTable_management(Path, Name)
    except:
        sErrors = gp.GetMessages(2)
        raise ReportError (sErrors)  
    
    # adding fields
    try:
        gp.AddField(OutTable2, "Operace", "TEXT", 10)
        gp.AddField(OutTable2, "Hodnota", "DOUBLE", 15, 15)
        gp.AddField(OutTable2, "ciziFID", "TEXT", 10)
        gp.DeleteField(OutTable2, "Field1")
    except:
        sErrors = gp.GetMessages(2)
        raise ReportError (sErrors)
    
#---------------------------------------------------------------------------------------------------
# counting statistic
        
if count == 1:
    zaokrouhlene = count
else:
    stredni = (count/2)       
    print stredni
    zaokrouhlene = round(stredni)
    print zaokrouhlene
    
try:        
        
    # sum, min, max mean and median value:
    rady = gp.UpdateCursor(InTable)
    pocet = 0
    min = 99999999
    max = 0
    suma = 0
    radek = rady.Next()
    while radek <> None:
        hodnota = radek.GetValue(InField)
        suma = suma + hodnota
        if hodnota > max:
            max = hodnota
            radekMax = pocet        
        if hodnota < min:
            min = hodnota
            radekMin = pocet
        if not count == 1:
            if pocet == zaokrouhlene:
                median = radek.GetValue(InField)
                print median
        else: median = radek.GetValue(InField)
            
        pocet = pocet + 1    
        radek = rady.Next()
    rady = None
            
    # mean
    prumer = suma/count

except:
    sErrors = gp.GetMessages(2)
    raise ReportError (sErrors)    
            
# -----------------------------------------------------------------------------
# records to the table:

if OutTable <> "" and OutTable <> "#":      # if it exist
    rady1 = gp.InsertCursor(OutTable2)
    radek1 = rady1.NewRow()
    radek1.Operace = "suma"
    radek1.Hodnota = suma
    print "suma = " + str(suma)
    rady1.InsertRow(radek1)
                
    radek2 = rady1.NewRow()
    radek2.Operace = "max"
    radek2.Hodnota = max
    radek2.ciziFID = radekMax
    print "max = " + str(max)
    print "radekMax: " + str(radekMax)
    rady1.InsertRow(radek2)
                
    radek3 = rady1.NewRow()
    radek3.Operace = "min"
    radek3.Hodnota = min
    radek3.ciziFID = radekMin
    print "min = " + str(min)
    rady1.InsertRow(radek3)
                
    radek4 = rady1.NewRow()
    radek4.Operace = "prumer"
    radek4.Hodnota = prumer
    print prumer
    rady1.InsertRow(radek4)
            
    radek5 = rady1.NewRow()
    radek5.Operace = "med"
    radek5.Hodnota = median
    print median
    rady1.InsertRow(radek5)
            
    rady1 = None

#----------------------------------------------------------------
# message with results

InName = os.path.basename(InTable)    
              
gp.AddMessage("\n STATISTICKE VYHODNOCENI"'\n'
                'v "' + str(InName) + '" v poli "' + str(InField) + '":\n'
                "Suma = " + str(suma) + '\n'
                "Min = " + str(min) + '\n'
                "Max = " + str(max) + '\n'
                "Prumer = " + str(prumer) + '\n'
                "Median = " + str(median) + '\n')

# to text file, if it exist
if OutFile <> "" and OutFile <> "#":       
    OutTxtFile.write(" STATISTICKE VYHODNOCENI"'\n'
                    'v "' + str(InName) + '" v poli "' + str(InField) + '":\n\n'
                    "Suma = " + str(suma) + '\n'
                    "Min = " + str(min) + '\n'
                    "Max = " + str(max) + '\n'
                    "Prumer = " + str(prumer) + '\n'
                    "Median = " + str(median) + '\n')
    
    # close the text file
    OutTxtFile.flush()
    OutTxtFile.close()


gp = None
   