#===============================================================================
# Statistic.py
# calculate sum, min, max, med and mean value
# Author: Katerina PAVKOVA, 2008
#===============================================================================

# import systems modules 
import arcgisscripting, string, math, sys, locale

# import helper functions
from HelperFunctions import *

# create geoprocessor object
gp = arcgisscripting.create()

# input
try:
    InTable = sys.argv[1]                 # Table View
    InField = sys.argv[2]                 # Field
    OutTable = sys.argv[3]                # Table
    OutFile = sys.argv[4]                 # Text File

#-------------------------------------------------------
# wrong text file parameter error
    if ".txt" not in OutFile:            # file do not contain .txt  
        OutFile = str(OutFile) + ".txt"
        print OutFile

    if os.path.dirname(OutFile) == "":
        if not os.path.dirname(InTable) == "":
            TextPath = os.path.dirname(InTable)
            gp.AddWarning ('Textovy soubor "' + str(OutFile) + '" je ulozen v "' + str(TextPath) + '\\".')
            print TextPath
            OutFile = str(TextPath) + "\\" + str(OutFile)
            print "poprvee " + str(OutFile)
        
        else:
            TextPath = gp.workspace = "C:/temp/"
            gp.AddWarning ('Textovy soubor "' + str(OutFile) + '" je ulozen v "C:/temp/".')
            OutFile = str(TextPath) + str(OutFile)
            print "podruhee " + str(OutFile)
        
            if not os.path.exists("C:/temp/"):
                message = '\n''Neexistujici adresar "C:/temp/"\nJe nutne zadat i cestu, kde ma byt soubor vytvoren.\n\n'
                error = gp.GetMessages(2)
                OutMessage = message + "... " + error
                raise ReportError (OutMessage)    

    OutTxtFile = open(OutFile, "w")       
   
except: raise ReportError (msgParseErr)

#-----------------------------------------------------------------------------

pocetZaznamu = gp.GetCount(InTable)                    # osetreni chyby, ze nejsou zadne zaznamy                       
if pocetZaznamu < 1:
    raise ReportError (msgNoRecsErr)
lsFiles = [OutTable]

print "pocet zaznamu = " + str(pocetZaznamu)

# listing poli, pro zjisteni typu vlozeneho pole:
seznamFields = gp.ListFields(InTable)
Field = seznamFields.Next()
while Field:
    if Field.Name == InField:
        typ = Field.Type
    Field = seznamFields.Next()
print typ

# chyba spatne vlozeneho pole
if typ <> "SmallInteger" and typ <> "Double" and typ <> "Integer" and typ <> "Single":
#typ <> "Short":
    clean_up(lsFiles)
    zprava = "Urcene pole nelze statisticky zpracovat \n\n"
    Errors = gp.GetMessages(2)
    OutMessage = zprava + "... " + Errors
    raise ReportError (OutMessage)
    

#-----------------------------------------------------------------------------
# vytvoreni Tabulky:

if ".dbf" not in OutTable:
        OutTable = str(OutTable) + ".dbf"
        print OutTable

if os.path.dirname(OutTable) == "":
    if not os.path.dirname(InTable) == "":
        Path = os.path.dirname(InTable)
        gp.AddWarning ('Tabulka "' + str(OutTable) + '" je ulozena v "' + str(Path) + '\\".')
        print "cesta1 = " + str(Path)
        OutTable = str(Path) + "\\" + str(OutTable)
        print "outtable = " + str(OutTable)

    else:
        Path = gp.workspace = "C:/temp/"
        print Path
        gp.AddWarning ('Tabulka "' + str(OutTable) + '" je ulozena v "C:/temp/".')
        OutTable = str(Path) + str(OutTable)

        if not os.path.exists("C:/temp/"):
            message = '\n''Neexistujici adresar "C:/temp/"\nVysledne tabulce je treba zapsat i cestu, kde ma byt ulozena.\n\n'
            error = gp.GetMessages(2)
            OutMessage = message + "... " + error
            raise ReportError (OutMessage)
     
Path, Name = os.path.split(OutTable)
print Path, Name

  
   
try:
    OutTable2 = gp.CreateTable_management(Path, Name)
except:
    sErrors = gp.GetMessages(2)
    raise ReportError (sErrors)  
    
# vlozeni poli
try:
    gp.AddField(OutTable2, "Operace", "TEXT", 10)
    gp.AddField(OutTable2, "Hodnota", "DOUBLE", 15, 15)
    gp.AddField(OutTable2, "ciziFID", "TEXT", 10)
    gp.DeleteField(OutTable2, "Field1")
except:
    sErrors = gp.GetMessages(2)
    raise ReportError (sErrors)
    
#----------------------------------------------------------------------------
# nechapu proc mi to 0.5 zaokrouhluje dolu!!! jinak by tam bylo jen normalne - 1 a ted tam neni nic
# ze by to proste dycky zaokrouhlovalo dolu???
        
if pocetZaznamu == 1:
    zaokrouhlene = pocetZaznamu
else:
    stredni = (pocetZaznamu/2)       
    print stredni
    zaokrouhlene = round(stredni)
    print zaokrouhlene
    
try:        # pocitani statistiky
        
    # sum, min a max, prum  a med hodnota:
    rady = gp.UpdateCursor(InTable)
    pocet = 0
    min = 99999999
    max = 0
    suma = 0
    radek = rady.Next()
    while radek <> None:
        hodnota = radek.GetValue(InField)
        suma = suma + hodnota
        if hodnota > max:
            max = hodnota
            radekMax = pocet        
        if hodnota < min:
            min = hodnota
            radekMin = pocet
        if not pocetZaznamu == 1:
            if pocet == zaokrouhlene:
                median = radek.GetValue(InField)
                print median
        else: median = radek.GetValue(InField)
        
        pocet = pocet + 1    
        radek = rady.Next()
    rady = None
        
    # vypocet prumeru:
    prumer = suma/pocetZaznamu
        
    #medianu
    stredni = (pocetZaznamu/2) - 1
    print stredni
    zaokrouhlene = round(stredni)
    print zaokrouhlene
        
    # -----------------------------------------------------------------------------
    # zapis do tabulky:
            
    rady1 = gp.InsertCursor(OutTable2)
    radek1 = rady1.NewRow()
    radek1.Operace = "suma"
    radek1.Hodnota = suma
    print "suma = " + str(suma)
    rady1.InsertRow(radek1)
            
    radek2 = rady1.NewRow()
    radek2.Operace = "max"
    radek2.Hodnota = max
    radek2.ciziFID = radekMax
    print "max = " + str(max)
    print "radekMax: " + str(radekMax)
    rady1.InsertRow(radek2)
            
    radek3 = rady1.NewRow()
    radek3.Operace = "min"
    radek3.Hodnota = min
    radek3.ciziFID = radekMin
    print "min = " + str(min)
    rady1.InsertRow(radek3)
            
    radek4 = rady1.NewRow()
    radek4.Operace = "prumer"
    radek4.Hodnota = prumer
    print prumer
    rady1.InsertRow(radek4)
        
    radek5 = rady1.NewRow()
    radek5.Operace = "med"
    radek5.Hodnota = median
    print median
    rady1.InsertRow(radek5)
        
    rady1 = None

    InName = os.path.basename(InTable)    
            
    gp.AddMessage("\n STATISTICKE VYHODNOCENI"'\n'
                  'v "' + str(InName) + '\n'
                  "Suma = " + str(suma) + '\n'
                  "Min = " + str(min) + '\n'
                  "Max = " + str(max) + '\n'
                  "Prumer = " + str(prumer) + '\n'
                  "Median = " + str(median) + '\n')

    OutTxtFile.write(" STATISTICKE VYHODNOCENI"'\n'
                  'v "' + str(InName) + '" \n\n'
                  "Suma = " + str(suma) + '\n'
                  "Min = " + str(min) + '\n'
                  "Max = " + str(max) + '\n'
                  "Prumer = " + str(prumer) + '\n'
                  "Median = " + str(median) + '\n')

    # close the text file
    OutTxtFile.flush()
    OutTxtFile.close()
            
        
except:
    gp.GetMessages(2) 


gp = None

          
##--------------------------------------------------------------------------------------
##seznamMin.append(pocet)
##seznamMin[-1:]    # vezme posledni ze seznamu.

##rows = gp.UpdateCursor(InTable)
##row = rows.Next()
##while row <> None:
##    if row.FID == zaokrouhlene:
##        median = row.GetValue(InField)
##        print median
##    row = rows.Next()
##rows = None
##print "seznam min: " + str(seznamMin[-1:])

"""
# na pokusy:
Path, Name = os.path.split(OutTable)
print Path

if ".dbf" not in os.path.basename(OutTable):  # kdyz neni vlozena koncovka .dbf - funguje!
        tableInfo = gp.Describe(os.path.dirname(OutTable))
        if tableInfo.WorkspaceType == "FileSystem":
            OutTable = OutTable + ".dbf"

if Path == "":
    Path = "C:/temp/"
    gp.AddMessage("Protoze k vysledne tabulce nebylo zadano pole je ulozena v C:/temp/.")"""





   