#===============================================================================
# numberOfEntity.py
# count number of entities in each cathegory
# Author: Katerina PAVKOVA, 2008
#===============================================================================

# import systems modules
import sys, os, locale, arcgisscripting

#  import helper functions
from HelperFunctions import *

# create geoprocessor object
gp = arcgisscripting.create()

# input
try:
    InFeature = sys.argv[1]                 # Input Feature Class
    InField = sys.argv[2]                   # Input Field
    OutFile = sys.argv[3]                   # Text File
    
except: raise ReportError (msgParseErr)

#-----------------------------------------------------------------------------------------
# wrong text file parameter error

if OutFile <> "" and OutFile <> "#":     # if this parameter exist
    if ".txt" not in OutFile:            # if text file do not contain ".txt"
        OutFile = str(OutFile) + ".txt"
        print OutFile

    # if text file do not contain direction folder path
    if os.path.dirname(OutFile) == "":
        if not os.path.dirname(InFeature) == "":
            TextPath = os.path.dirname(InFeature)
            gp.AddWarning ('Text file with results"' + str(OutFile) + '" is saved in "' + str(TextPath) + '\\".')
            print TextPath
            OutFile = str(TextPath) + "\\" + str(OutFile)
            print "poprvee " + str(OutFile)
        
        else:
            TextPath = gp.workspace = "C:/temp/"
            gp.AddWarning ('Text file with results "' + str(OutFile) + '" is saved in "C:/temp/".')
            OutFile = str(TextPath) + str(OutFile)
            print "podruhee " + str(OutFile)
        
            if not os.path.exists("C:/temp/"):
                message = '\n''"C:/temp/" does not exist. \nPlease specify a path to the results file.\n\n'
                error = gp.GetMessages(2)
                OutMessage = message + "... " + error
                raise ReportError (OutMessage)    

    # creating text file
    OutTxtFile = open(OutFile, "w")    

#-----------------------------------------------------------------------------------
# no records error
count = gp.GetCount(InFeature)                        # Counting records                                        
if count < 1:
        raise ReportError (msgNoRecsErr)

#------------------------------------------------------------------------------------

InName = os.path.basename(InFeature)
gp.AddMessage("\n NUMBER OF ENTITY BY CATEGORY"'\n'
              'in "' + str(InName) +'" in field "' + str(InField) + '" are:\n'
              + str(count) + ' records:\n')
if OutFile <> "" and OutFile <> "#":     # if this parameter exist
    OutTxtFile.write(" NUMBER OF ENTITY BY CATEGORY"'\n'
                  'in "' + str(InName) +'" in field "' + str(InField) + '" are:\n\n'
                  + str(count) + ' records:\n\n')

#--------------------------------------------------------------------------------------
# counting number of entities

# put each category in list
list = []

rows1 = gp.UpdateCursor(InFeature)
row1 = rows1.Next()
while row1:
    entry = row1.GetValue(InField)                     # getting values
    if entry not in list: list.append(entry)
    row1 = rows1.Next()
rows1 = None

# looping through list and counting number of their values
for i in list:
    number = 0
    
    rows = gp.UpdateCursor(InFeature)
    row = rows.Next()
    while row:
        value = row.GetValue(InField)
        if value == i:
            number = number + 1      
    
        row = rows.Next()
    rows = None

    # writing a number of each count   
    gp.AddMessage(str(number) + " in category " + str(i))
    if OutFile <> "" and OutFile <> "#":     # if this parameter exist
        OutTxtFile.write(str(number) + " in category " + str(i) + '\n')
    number = 1
    
gp.AddMessage('\n')

if OutFile <> "" and OutFile <> "#":     # if this parameter exist
    # close the text file
    OutTxtFile.flush()
    OutTxtFile.close()

gp = None