# ============================================================================
# TheShape.py
# count The Shape Index
# author: Katerina PAVKOVA, 2008
# ============================================================================

# import systems modules
import sys, math, arcgisscripting

# import helper functions
from HelperFunctions import *

# create geoprocessor object
gp = arcgisscripting.create()

# input
try:
    InPolygFC = sys.argv[1]                        # Feature Class/Layer
except: raise ReportError (msgParseErr)

#------------------------------------------------------------------------------------
# no records error
count = gp.GetCount(InPolygFC)                        # Counting records                                        
if count < 1:
        raise ReportError (msgNoRecsErr)

 
# feature type error
lsFiles = [InPolygFC]
properties = get_featureclass_properties(InPolygFC)
if properties.sShapeType <> "polygon":              # FC musi byt polygon
    clean_up(lsFiles)
    raise ReportError(msgPolyOnlyErr)

#----------------------------------------------------------------------------------
# listing fields and getting their names
listFields = gp.ListFields(InPolygFC)
dscFields = []
Field = listFields.Next()                           # looping through list of Fields
while Field:                                        # to get their names
    name = Field.Name
    dscFields.append(name)
    Field = listFields.Next()

# checking if field exists in list of fields names, if not it is added
indexFieldDi = "Di"
try:
    if indexFieldDi not in dscFields: gp.AddField_management(InPolygFC, indexFieldDi, "DOUBLE")
    else: gp.AddWarning("Values in existing field 'Di' will be rewrite")
except: raise gp.GetMessages(2)


# listing only needed fields
sFieldList = properties.sShapeField + ";" + indexFieldDi

#===============================================================================
# vypocet indexu, looping outputFC tabulkou
rows = gp.UpdateCursor(InPolygFC,"","",sFieldList)
number = 1
row = rows.Next()
while row <> None:
    geometry = row.GetValue (properties.sShapeField)
    area = geometry.Area                
    
    perimeter = geometry.Length

    index = perimeter/(2*math.sqrt(area*math.pi))
    
    row.SetValue(indexFieldDi, index)               # recording index value to the table   
    rows.UpdateRow(row)

    # displaying percentage of looping
    if number == round(count/4):
        gp.AddMessage('\n25% complete')
    if number == round(count/2):
        gp.AddMessage('50% complete')
    if number == round((count/4)*3):
        gp.AddMessage('75% complete ...')

    number = number + 1        
    
    row = rows.Next()
rows = None

gp.AddMessage("\n Index values are in attribute table"'\n')

gp = None